com.hazelcast.com.fasterxml.jackson.core.json

## Class UTF8DataInputJsonParser

- java.lang.Object
- - com.hazelcast.com.fasterxml.jackson.core.JsonParser
  - - com.hazelcast.com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.hazelcast.com.fasterxml.jackson.core.base.ParserBase
      - - com.hazelcast.com.fasterxml.jackson.core.json.UTF8DataInputJsonParser

- All Implemented Interfaces:
    Versioned, Closeable, AutoCloseable

      public class UTF8DataInputJsonParser
      extends ParserBase

  This is a concrete implementation of `JsonParser`, which is based on a `DataInput` as the input source.

  Due to limitations in look-ahead (basically there's none), as well as overhead of reading content mostly byte-by-byte, there are some minor differences from regular streaming parsing. Specifically:

  - Input location is not being tracked, as offsets would need to be updated for each read from all over the place; if caller wants this information, it has to track this with `DataInput`.
  - As a consequence linefeed handling is removed so all white-space is equal; and checks are simplified NOT to check for control characters
  Since:
    2.8

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonParser

      `JsonParser.Feature, JsonParser.NumberType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static int[]` | `_icLatin1`
    `protected DataInput` | `_inputData`
    `protected int` | `_nextByte` Sometimes we need buffering for just a single byte we read but have to "push back"
    `protected ObjectCodec` | `_objectCodec` Codec used for data binding when (if) requested; typically full `ObjectMapper`, but that abstract is not part of core package.
    `protected int[]` | `_quadBuffer` Temporary buffer used for name parsing.
    `protected ByteQuadsCanonicalizer` | `_symbols` Symbol table that contains field names encountered so far
    `protected boolean` | `_tokenIncomplete` Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.base.ParserBase

      `_binaryValue, _byteArrayBuilder, _closed, _currInputProcessed, _currInputRow, _currInputRowStart, _expLength, _fractLength, _inputEnd, _inputPtr, _intLength, _ioContext, _nameCopied, _nameCopyBuffer, _nextToken, _numberBigDecimal, _numberBigInt, _numberDouble, _numberInt, _numberLong, _numberNegative, _numTypesValid, _parsingContext, _textBuffer, _tokenInputCol, _tokenInputRow, _tokenInputTotal`

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.base.ParserMinimalBase

      `_currToken, _lastClearedToken, BD_MAX_INT, BD_MAX_LONG, BD_MIN_INT, BD_MIN_LONG, BI_MAX_INT, BI_MAX_LONG, BI_MIN_INT, BI_MIN_LONG, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonParser

      `_features, _requestPayload`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UTF8DataInputJsonParser(IOContext ctxt, int features, DataInput inputData, ObjectCodec codec, ByteQuadsCanonicalizer sym, int firstByte)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_closeInput()`
    `protected byte[]` | `_decodeBase64(Base64Variant b64variant)` Efficient handling for incremental parsing of base64-encoded textual content.
    `protected int` | `_decodeCharForError(int firstByte)`
    `protected char` | `_decodeEscaped()` Method that sub-classes must implement to support escaped sequences in base64-encoded sections.
    `protected void` | `_finishString()`
    `protected String` | `_getText2(JsonToken t)`
    `protected JsonToken` | `_handleApos()`
    `protected JsonToken` | `_handleInvalidNumberStart(int ch, boolean neg)` Method called if expected numeric value (due to leading sign) does not look like a number
    `protected String` | `_handleOddName(int ch)` Method called when we see non-white space character other than double quote, when expecting a field name.
    `protected JsonToken` | `_handleUnexpectedValue(int c)` Method for handling cases where first non-space character of an expected value token is not legal for standard JSON content.
    `protected void` | `_matchToken(String matchStr, int i)`
    `protected String` | `_parseAposName()`
    `protected String` | `_parseName(int i)`
    `protected JsonToken` | `_parseNegNumber()`
    `protected JsonToken` | `_parsePosNumber(int c)` Initial parsing method for number values.
    `protected int` | `_readBinary(Base64Variant b64variant, OutputStream out, byte[] buffer)`
    `protected void` | `_releaseBuffers()` Method called to release internal buffers owned by the base reader.
    `protected void` | `_reportInvalidChar(int c)`
    `protected void` | `_reportInvalidInitial(int mask)`
    `protected void` | `_reportInvalidToken(int ch, String matchedPart)`
    `protected void` | `_reportInvalidToken(int ch, String matchedPart, String msg)`
    `protected void` | `_skipString()` Method called to skim through rest of unparsed String value, if it is not needed.
    `void` | `finishToken()` Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval.
    `byte[]` | `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
    `ObjectCodec` | `getCodec()` Accessor for `ObjectCodec` associated with this parser, if any.
    `JsonLocation` | `getCurrentLocation()` Method that returns location of the last processed character; usually for error reporting purposes
    `Object` | `getInputSource()` Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with.
    `String` | `getText()` Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null.
    `int` | `getText(Writer writer)` Method to read the textual representation of the current token in chunks and pass it to the given Writer.
    `char[]` | `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
    `int` | `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
    `int` | `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
    `JsonLocation` | `getTokenLocation()` Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.
    `int` | `getValueAsInt()` Method that will try to convert value of current token to a int.
    `int` | `getValueAsInt(int defValue)` Method that will try to convert value of current token to a int.
    `String` | `getValueAsString()` Method that will try to convert value of current token to a `String`.
    `String` | `getValueAsString(String defValue)` Method that will try to convert value of current token to a `String`.
    `Boolean` | `nextBooleanValue()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null.
    `String` | `nextFieldName()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `JsonParser.getCurrentName()`, otherwise null.
    `int` | `nextIntValue(int defaultValue)` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:
    `long` | `nextLongValue(long defaultValue)` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:
    `String` | `nextTextValue()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null.
    `JsonToken` | `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
    `protected String` | `parseEscapedName(int[] quads, int qlen, int currQuad, int ch, int currQuadBytes)` Slower parsing method which is generally branched to when an escape sequence is detected (or alternatively for long names, one crossing input buffer boundary).
    `int` | `readBinaryValue(Base64Variant b64variant, OutputStream out)` Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
    `int` | `releaseBuffered(OutputStream out)` Method that can be called to push back any content that has been read but not consumed by the parser.
    `void` | `setCodec(ObjectCodec c)` Setter that allows defining `ObjectCodec` associated with this parser, if any.

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.base.ParserBase

      `_checkStdFeatureChanges, _decodeBase64Escape, _decodeBase64Escape, _eofAsNextChar, _getByteArrayBuilder, _getSourceReference, _handleEOF, _parseIntValue, _parseNumericValue, _reportMismatchedEndMarker, close, convertNumberToBigDecimal, convertNumberToBigInteger, convertNumberToDouble, convertNumberToInt, convertNumberToLong, disable, enable, getBigIntegerValue, getCurrentName, getCurrentValue, getDecimalValue, getDoubleValue, getFloatValue, getIntValue, getLongValue, getNumberType, getNumberValue, getParsingContext, getTokenCharacterOffset, getTokenColumnNr, getTokenLineNr, growArrayBy, hasTextCharacters, isClosed, isNaN, loadMore, loadMoreGuaranteed, overrideCurrentName, overrideStdFeatures, reportInvalidBase64Char, reportInvalidBase64Char, reset, resetAsNaN, resetFloat, resetInt, setCurrentValue, setFeatureMask, version`

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.base.ParserMinimalBase

      `_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _handleUnrecognizedCharacterEscape, _hasTextualNull, _reportError, _reportError, _reportError, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _throwUnquotedSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsLong, getValueAsLong, hasCurrentToken, hasToken, hasTokenId, isExpectedStartArrayToken, isExpectedStartObjectToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonParser

      `_codec, _constructError, _reportUnsupportedOperation, canParseAsync, canReadObjectId, canReadTypeId, canUseSchema, configure, currentName, getBinaryValue, getBooleanValue, getByteValue, getEmbeddedObject, getFeatureMask, getFormatFeatures, getNonBlockingInputFeeder, getObjectId, getSchema, getShortValue, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, nextFieldName, overrideFormatFeatures, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, requiresCustomCodec, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _icLatin1

          protected static final int[] _icLatin1

    - #### _objectCodec

          protected ObjectCodec _objectCodec

      Codec used for data binding when (if) requested; typically full `ObjectMapper`, but that abstract is not part of core package.

    - #### _symbols

          protected final ByteQuadsCanonicalizer _symbols

      Symbol table that contains field names encountered so far

    - #### _quadBuffer

          protected int[] _quadBuffer

      Temporary buffer used for name parsing.

    - #### _tokenIncomplete

          protected boolean _tokenIncomplete

      Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)

    - #### _inputData

          protected DataInput _inputData

    - #### _nextByte

          protected int _nextByte

      Sometimes we need buffering for just a single byte we read but have to "push back"

  - ### Constructor Detail

    - #### UTF8DataInputJsonParser

          public UTF8DataInputJsonParser(IOContext ctxt,
                                         int features,
                                         DataInput inputData,
                                         ObjectCodec codec,
                                         ByteQuadsCanonicalizer sym,
                                         int firstByte)

  - ### Method Detail

    - #### getCodec

          public ObjectCodec getCodec()

      Description copied from class: `JsonParser`
      Accessor for `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).
      Specified by:
        `getCodec` in class `JsonParser`

    - #### setCodec

          public void setCodec(ObjectCodec c)

      Description copied from class: `JsonParser`
      Setter that allows defining `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).
      Specified by:
        `setCodec` in class `JsonParser`

    - #### releaseBuffered

          public int releaseBuffered(OutputStream out)
                              throws IOException

      Description copied from class: `JsonParser`
      Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given stream if possible; if underlying input is byte-based it can released, if not (char-based) it can not.
      Overrides:
        `releaseBuffered` in class `JsonParser`
      Returns:
        -1 if the underlying content source is not byte based (that is, input can not be sent to `OutputStream`; otherwise number of bytes released (0 if there was nothing to release)
      Throws:
        `IOException` - if write to stream threw exception

    - #### getInputSource

          public Object getInputSource()

      Description copied from class: `JsonParser`
      Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with. Note that returned value may be null in some cases; including case where parser implementation does not want to exposed raw source to caller. In cases where input has been decorated, object returned here is the decorated version; this allows some level of interaction between users of parser and decorator object.

      In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

      Overrides:
        `getInputSource` in class `JsonParser`

    - #### _closeInput

          protected void _closeInput()
                              throws IOException

      Specified by:
        `_closeInput` in class `ParserBase`
      Throws:
        `IOException`

    - #### _releaseBuffers

          protected void _releaseBuffers()
                                  throws IOException

      Method called to release internal buffers owned by the base reader. This may be called along with `_closeInput()` (for example, when explicitly closing this reader instance), or separately (if need be).
      Overrides:
        `_releaseBuffers` in class `ParserBase`
      Throws:
        `IOException`

    - #### getText

          public String getText()
                         throws IOException

      Description copied from class: `JsonParser`
      Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.
      Specified by:
        `getText` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### getText

          public int getText(Writer writer)
                      throws IOException

      Description copied from class: `JsonParser`
      Method to read the textual representation of the current token in chunks and pass it to the given Writer. Conceptually same as calling:

            writer.write(parser.getText());

      but should typically be more efficient as longer content does need to be combined into a single `String` to return, and write can occur directly from intermediate buffers Jackson uses.
      Overrides:
        `getText` in class `JsonParser`
      Returns:
        The number of characters written to the Writer
      Throws:
        `IOException`

    - #### getValueAsString

          public String getValueAsString()
                                  throws IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), default value of null will be returned; no exceptions are thrown.
      Overrides:
        `getValueAsString` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### getValueAsString

          public String getValueAsString(String defValue)
                                  throws IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), specified default value will be returned; no exceptions are thrown.
      Overrides:
        `getValueAsString` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### getValueAsInt

          public int getValueAsInt()
                            throws IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsInt` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### getValueAsInt

          public int getValueAsInt(int defValue)
                            throws IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsInt` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### _getText2

          protected final String _getText2(JsonToken t)

    - #### getTextCharacters

          public char[] getTextCharacters()
                                   throws IOException

      Description copied from class: `JsonParser`
      Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:
      - Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
      - Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

      Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

      The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

      Specified by:
        `getTextCharacters` in class `ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextLength

          public int getTextLength()
                            throws IOException

      Description copied from class: `JsonParser`
      Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
      Specified by:
        `getTextLength` in class `ParserMinimalBase`
      Returns:
        Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
      Throws:
        `IOException`

    - #### getTextOffset

          public int getTextOffset()
                            throws IOException

      Description copied from class: `JsonParser`
      Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
      Specified by:
        `getTextOffset` in class `ParserMinimalBase`
      Returns:
        Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
      Throws:
        `IOException`

    - #### getBinaryValue

          public byte[] getBinaryValue(Base64Variant b64variant)
                                throws IOException

      Description copied from class: `JsonParser`
      Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

      Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

      Overrides:
        `getBinaryValue` in class `ParserBase`
      Parameters:
        `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
      Returns:
        Decoded binary data
      Throws:
        `IOException`

    - #### readBinaryValue

          public int readBinaryValue(Base64Variant b64variant,
                                     OutputStream out)
                              throws IOException

      Description copied from class: `JsonParser`
      Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
      Overrides:
        `readBinaryValue` in class `JsonParser`
      Parameters:
        `b64variant` - base64 variant to use
        `out` - Output stream to use for passing decoded binary data
      Returns:
        Number of bytes that were decoded and written via `OutputStream`
      Throws:
        `IOException`

    - #### _readBinary

          protected int _readBinary(Base64Variant b64variant,
                                    OutputStream out,
                                    byte[] buffer)
                             throws IOException

      Throws:
        `IOException`

    - #### nextToken

          public JsonToken nextToken()
                              throws IOException

      Description copied from class: `JsonParser`
      Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.
      Specified by:
        `nextToken` in class `ParserMinimalBase`
      Returns:
        Next token from the stream, if any found, or null to indicate end-of-input
      Throws:
        `IOException`

    - #### finishToken

          public void finishToken()
                           throws IOException

      Description copied from class: `JsonParser`
      Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval. This is usually used to ensure that the token end location is available, as well as token contents (similar to what calling, say `JsonParser.getTextCharacters()`, would achieve).

      Note that for many dataformat implementations this method will not do anything; this is the default implementation unless overridden by sub-classes.

      Overrides:
        `finishToken` in class `JsonParser`
      Throws:
        `IOException`

    - #### nextFieldName

          public String nextFieldName()
                               throws IOException

      Description copied from class: `JsonParser`
      Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `JsonParser.getCurrentName()`, otherwise null.
      Overrides:
        `nextFieldName` in class `JsonParser`
      Throws:
        `IOException`

    - #### nextTextValue

          public String nextTextValue()
                               throws IOException

      Description copied from class: `JsonParser`
      Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null. It is functionally equivalent to:

            return (nextToken() == JsonToken.VALUE_STRING) ? getText() : null;

      but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.
      Overrides:
        `nextTextValue` in class `JsonParser`
      Throws:
        `IOException`

    - #### nextIntValue

          public int nextIntValue(int defaultValue)
                           throws IOException

      Description copied from class: `JsonParser`
      Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:

            return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getIntValue() : defaultValue;

      but may be faster for parser to process, and can therefore be used if caller expects to get an int value next from input.
      Overrides:
        `nextIntValue` in class `JsonParser`
      Throws:
        `IOException`

    - #### nextLongValue

          public long nextLongValue(long defaultValue)
                             throws IOException

      Description copied from class: `JsonParser`
      Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:

            return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getLongValue() : defaultValue;

      but may be faster for parser to process, and can therefore be used if caller expects to get a long value next from input.
      Overrides:
        `nextLongValue` in class `JsonParser`
      Throws:
        `IOException`

    - #### nextBooleanValue

          public Boolean nextBooleanValue()
                                   throws IOException

      Description copied from class: `JsonParser`
      Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null. It is functionally equivalent to:

            JsonToken t = nextToken();
            if (t == JsonToken.VALUE_TRUE) return Boolean.TRUE;
            if (t == JsonToken.VALUE_FALSE) return Boolean.FALSE;
            return null;

      but may be faster for parser to process, and can therefore be used if caller expects to get a Boolean value next from input.
      Overrides:
        `nextBooleanValue` in class `JsonParser`
      Throws:
        `IOException`

    - #### _parsePosNumber

          protected JsonToken _parsePosNumber(int c)
                                       throws IOException

      Initial parsing method for number values. It needs to be able to parse enough input to be able to determine whether the value is to be considered a simple integer value, or a more generic decimal value: latter of which needs to be expressed as a floating point number. The basic rule is that if the number has no fractional or exponential part, it is an integer; otherwise a floating point number.

      Because much of input has to be processed in any case, no partial parsing is done: all input text will be stored for further processing. However, actual numeric value conversion will be deferred, since it is usually the most complicated and costliest part of processing.

      Throws:
        `IOException`

    - #### _parseNegNumber

          protected JsonToken _parseNegNumber()
                                       throws IOException

      Throws:
        `IOException`

    - #### _parseName

          protected final String _parseName(int i)
                                     throws IOException

      Throws:
        `IOException`

    - #### parseEscapedName

          protected final String parseEscapedName(int[] quads,
                                                  int qlen,
                                                  int currQuad,
                                                  int ch,
                                                  int currQuadBytes)
                                           throws IOException

      Slower parsing method which is generally branched to when an escape sequence is detected (or alternatively for long names, one crossing input buffer boundary). Needs to be able to handle more exceptional cases, gets slower, and hance is offlined to a separate method.
      Throws:
        `IOException`

    - #### _handleOddName

          protected String _handleOddName(int ch)
                                   throws IOException

      Method called when we see non-white space character other than double quote, when expecting a field name. In standard mode will just throw an exception; but in non-standard modes may be able to parse name.
      Throws:
        `IOException`

    - #### _parseAposName

          protected String _parseAposName()
                                   throws IOException

      Throws:
        `IOException`

    - #### _finishString

          protected void _finishString()
                                throws IOException

      Overrides:
        `_finishString` in class `ParserBase`
      Throws:
        `IOException`

    - #### _skipString

          protected void _skipString()
                              throws IOException

      Method called to skim through rest of unparsed String value, if it is not needed. This can be done bit faster if contents need not be stored for future access.
      Throws:
        `IOException`

    - #### _handleUnexpectedValue

          protected JsonToken _handleUnexpectedValue(int c)
                                              throws IOException

      Method for handling cases where first non-space character of an expected value token is not legal for standard JSON content.
      Throws:
        `IOException`

    - #### _handleApos

          protected JsonToken _handleApos()
                                   throws IOException

      Throws:
        `IOException`

    - #### _handleInvalidNumberStart

          protected JsonToken _handleInvalidNumberStart(int ch,
                                                        boolean neg)
                                                 throws IOException

      Method called if expected numeric value (due to leading sign) does not look like a number
      Throws:
        `IOException`

    - #### _matchToken

          protected final void _matchToken(String matchStr,
                                           int i)
                                    throws IOException

      Throws:
        `IOException`

    - #### _decodeEscaped

          protected char _decodeEscaped()
                                 throws IOException

      Description copied from class: `ParserBase`
      Method that sub-classes must implement to support escaped sequences in base64-encoded sections. Sub-classes that do not need base64 support can leave this as is
      Overrides:
        `_decodeEscaped` in class `ParserBase`
      Throws:
        `IOException`

    - #### _decodeCharForError

          protected int _decodeCharForError(int firstByte)
                                     throws IOException

      Throws:
        `IOException`

    - #### _reportInvalidToken

          protected void _reportInvalidToken(int ch,
                                             String matchedPart)
                                      throws IOException

      Throws:
        `IOException`

    - #### _reportInvalidToken

          protected void _reportInvalidToken(int ch,
                                             String matchedPart,
                                             String msg)
                                      throws IOException

      Throws:
        `IOException`

    - #### _reportInvalidChar

          protected void _reportInvalidChar(int c)
                                     throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _reportInvalidInitial

          protected void _reportInvalidInitial(int mask)
                                        throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _decodeBase64

          protected final byte[] _decodeBase64(Base64Variant b64variant)
                                        throws IOException

      Efficient handling for incremental parsing of base64-encoded textual content.
      Throws:
        `IOException`

    - #### getTokenLocation

          public JsonLocation getTokenLocation()

      Description copied from class: `ParserBase`
      Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.
      Overrides:
        `getTokenLocation` in class `ParserBase`

    - #### getCurrentLocation

          public JsonLocation getCurrentLocation()

      Description copied from class: `ParserBase`
      Method that returns location of the last processed character; usually for error reporting purposes
      Overrides:
        `getCurrentLocation` in class `ParserBase`

Copyright © 2019. All rights reserved.